﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals

	Private Root As B4XView
	Private xui As XUI
	Private ASScheduler_MonthView1 As ASScheduler_MonthView
	
	Private xlbl_ThemeMode As B4XView
End Sub

Public Sub Initialize
	
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("frm_main")
	
	B4XPages.SetTitle(Me,"MonthView Example")
	
	#If B4I
	Wait For B4XPage_Resize (Width As Int, Height As Int)
	#End If
	
	ASScheduler_MonthView1.API.ClearAppointments
	ASScheduler_MonthView1.API.ClearBlackouts
	
	
	'HeatMap Example Data
'	For i = 1 To 40 -1
'		Dim p As Period
'		p.Initialize
'		p.Days = i
'		Dim Date As Long = DateUtils.AddPeriod(DateTime.Now,p)
'		For z = 1 To Rnd(2,12) -1
'			ASScheduler_MonthView1.API.CreateAppointment(ASSchedulerUtils.CreateASScheduler_AppointmentRecurring(0,"Test1","Description",xui.Color_ARGB(255,73, 98, 164),False,Date,Date+DateTime.TicksPerHour,False,"day",7))
'		Next
'	Next
	
	'Minimalism Example Data
'	For i = 1 To 40 -1
'		Dim p As Period
'		p.Initialize
'		p.Days = i
'		Dim Date As Long = DateUtils.AddPeriod(DateTime.Now,p)
'		For z = 1 To 4 -1
'			ASScheduler_MonthView1.API.CreateAppointment(ASSchedulerUtils.CreateASScheduler_AppointmentRecurring(0,"Test1","Description",xui.Color_ARGB(255,Rnd(0,256), Rnd(0,256), Rnd(0,256)),False,Date,Date+DateTime.TicksPerHour,False,"day",7))
'		Next
'	Next
	
	If ASScheduler_MonthView1.API.GetAppointmentCount = 0 Then 'Add Test Appointments, only if the SQL are empty
		Dim p As Period
		p.Initialize
		p.Days = 3
		
		ASScheduler_MonthView1.API.CreateAppointment(ASSchedulerUtils.CreateASScheduler_AppointmentRecurring(0,"Test1","Description",xui.Color_ARGB(255,73, 98, 164),False,DateTime.Now,DateUtils.AddPeriod(DateTime.Now,p),True,"day",7))
		p.Days = 2
		ASScheduler_MonthView1.API.CreateAppointment(ASSchedulerUtils.CreateASScheduler_Appointment(0,"Test2","Description",xui.Color_ARGB(255,45, 136, 121),False,DateTime.Now,DateUtils.AddPeriod(DateTime.Now,p)))
		ASScheduler_MonthView1.API.CreateAppointment(ASSchedulerUtils.CreateASScheduler_Appointment(0,"Test3","Description",xui.Color_ARGB(255,141, 68, 173),False,DateUtils.AddPeriod(DateTime.Now,p),DateUtils.AddPeriod(DateTime.Now,p)))
	
		p.Days = -2
		For i = 0 To 15 -1
			ASScheduler_MonthView1.API.CreateAppointment(ASSchedulerUtils.CreateASScheduler_Appointment(0,"Test" & i,"Description",xui.Color_ARGB(255,45, 136, 121),False,DateUtils.AddPeriod(DateTime.Now,p),DateUtils.AddPeriod(DateTime.Now,p)))
		Next
	
	
		p.Days = -12
		ASScheduler_MonthView1.API.CreateBlackout(ASSchedulerUtils.CreateASScheduler_Blackout(0,DateUtils.AddPeriod(DateTime.Now,p),DateUtils.AddPeriod(DateTime.Now,p) + (DateTime.TicksPerDay*4)))
	
		ASScheduler_MonthView1.RefreshScheduler
	End If
	
	#If B4I
	ASScheduler_MonthView1.Base_Resize(Width,Height)
	#End If
	
	ASScheduler_MonthView1.CreateScheduler 'makes the scheduler visible
	'ASScheduler_MonthView1.NumberOfWeeks = 2
	'ASScheduler_MonthView1.RefreshScheduler 'Rebuilds the visible area
	
'	Sleep(4000)
'	ASScheduler_MonthView1.SchedulerFunction = ASScheduler_MonthView1.SchedulerFunction_HeatMap
'	ASScheduler_MonthView1.RefreshScheduler
End Sub

Private Sub ASScheduler_MonthView1_DayClick(Date As Long)
	Log("ASScheduler_MonthView1_DayClick: " & DateUtils.TicksToString(Date))
	wait for (xui.MsgboxAsync("ASScheduler_MonthView1_DayClick: " & DateUtils.TicksToString(Date),"Test").As(Object)) Msgbox_Result (Result As Int)
End Sub

Private Sub ASScheduler_MonthView1_DayLongClick(Date As Long)
	Log("ASScheduler_MonthView1_DayLongClick: " & DateUtils.TicksToString(Date))
	wait for (xui.MsgboxAsync("ASScheduler_MonthView1_DayLongClick: " & DateUtils.TicksToString(Date),"Test").As(Object)) Msgbox_Result (Result As Int)
End Sub

Private Sub ASScheduler_MonthView1_AppointmentClick(Appointment As ASScheduler_Appointment)
	Log("ASScheduler_MonthView1_AppointmentClick: " & Appointment.Name)
	wait for (xui.MsgboxAsync("ASScheduler_MonthView1_AppointmentClick: " & Appointment.Name,"Test").As(Object)) Msgbox_Result (Result As Int)
End Sub

Private Sub ASScheduler_MonthView1_AppointmentLongClick(Appointment As ASScheduler_Appointment)
	Log("ASScheduler_MonthView1_AppointmentLongClick: " & Appointment.Name)
	wait for (xui.MsgboxAsync("ASScheduler_MonthView1_AppointmentLongClick: " & Appointment.Name,"Test").As(Object)) Msgbox_Result (Result As Int)
End Sub

Private Sub ASScheduler_MonthView1_HiddenAppointmentClick(ListOfAppointments As List)
	For Each Appointment As ASScheduler_Appointment In ListOfAppointments
		Log("ASScheduler_MonthView1_HiddenAppointmentClick: " & Appointment.Name)
		wait for (xui.MsgboxAsync("ASScheduler_MonthView1_HiddenAppointmentClick: " & Appointment.Name,"Test").As(Object)) Msgbox_Result (Result As Int)
	Next
End Sub

Private Sub ASScheduler_MonthView1_HiddenAppointmentLongClick(ListOfAppointments As List)
	For Each Appointment As ASScheduler_Appointment In ListOfAppointments
		Log("ASScheduler_MonthView1_HiddenAppointmentLongClick: " & Appointment.Name)
		wait for (xui.MsgboxAsync("ASScheduler_MonthView1_HiddenAppointmentLongClick: " & Appointment.Name,"Test").As(Object)) Msgbox_Result (Result As Int)
	Next
End Sub

'**************Theming*****************

#If B4J
Private Sub xlbl_ThemeMode_MouseClicked (EventData As MouseEvent)
	SwitchTheme
End Sub

#Else
Private Sub xlbl_ThemeMode_Click
	SwitchTheme
End Sub
#End If

Private Sub SwitchTheme
	
	Dim Theme As ASScheduler_Theme
	Theme.Initialize
	
	If xlbl_ThemeMode.Tag = "Dark" Then
		xlbl_ThemeMode.Tag = "Light"
		xlbl_ThemeMode.Font = xui.CreateFontAwesome(25)
		xlbl_ThemeMode.Text = Chr(0xF186)
		xlbl_ThemeMode.TextColor = xui.Color_Black
		
		'Background Colors
		Theme.BackgroundColor_Body = xui.Color_White
		Theme.BackgroundColor_Header = xui.Color_White
		Theme.BackgroundColor_Timeline = xui.Color_White
		Theme.BackgroundColor_WeekNumber = xui.Color_Gray
		Theme.BackgroundColor_GridLine = xui.Color_ARGB(100,0,0,0)
		Theme.BackgroundColor_Blackout = xui.Color_ARGB(152,0,0,0)
		'Text Colors
		Theme.TextColor_Header = xui.Color_Black
		Theme.TextColor_Timeline = xui.Color_Black
		Theme.TextColor_WeekNumber = xui.Color_Black
		Theme.TextColor_Day_MonthView = xui.Color_Black
		
		
	Else
		xlbl_ThemeMode.Tag = "Dark"
		xlbl_ThemeMode.Font = xui.CreateMaterialIcons(25)
		xlbl_ThemeMode.Text = Chr(0xE430)
		xlbl_ThemeMode.TextColor = xui.Color_White
		
		'Background Colors
		Theme.BackgroundColor_Body = 0xFF202125
		Theme.BackgroundColor_Header = 0xFF131416
		Theme.BackgroundColor_WeekNumber = xui.Color_ARGB(255,32, 33, 37)
		Theme.BackgroundColor_GridLine = 0x64FFFFFF
		Theme.BackgroundColor_Blackout = xui.Color_ARGB(152,255,255,255)
		'Text Colors
		Theme.TextColor_Header = xui.Color_White
		Theme.TextColor_WeekNumber = xui.Color_White
		Theme.TextColor_Day_MonthView = xui.Color_White
		
	End If
	
	ASScheduler_MonthView1.SetTheme(Theme)
	ASScheduler_MonthView1.RefreshScheduler
	ASScheduler_MonthView1.RefreshHeader
	
	Root.SetColorAnimated(500,Root.Color,Theme.BackgroundColor_Body)
	
End Sub

Private Sub ASScheduler_MonthView1_FirstVisibleDay(Date As Long)
	Log("FirstVisibleDay: " & DateUtils.TicksToString(Date))
	DateTime.DateFormat = "dd.MM.yyyy"
	Date = Date + DateTime.TicksPerDay*6 'if a new month starts in the week
	B4XPages.SetTitle(Me,"MonthView Example - " & DateUtils.GetMonthName(Date) & " " & DateTime.GetYear(Date))
End Sub

Private Sub ASScheduler_MonthView1_LastVisibleDay(Date As Long)
	Log("LastVisibleDay: " & DateUtils.TicksToString(Date))
End Sub